
;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro snowFall_event,event
;event handler for the top base. does not do anything right now

return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro snowFallCleanup, base
;called no matter how the widget dies

widget_control, base, get_uvalue=object
obj_destroy, object

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro snowFallExit, event
;destroy the top level base
widget_control, event.top,/destroy

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro snowFall::update

self.oWindow->Draw, self.oCamera

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function snowFall::init, numSnowflakes=numSnowflakes, _extra=extra
;initialization routine for the snowFall

if not keyword_set(numSnowflakes) then numSnowflakes = 25
;initialize the super class
if (self->IDLgrModel::init(_extra=extra) ne 1) then return, 0

;Get the screen size.
device, get_screen_size = screenSize
xdim = screenSize[0]*.50 ;about 50 percent of the screen size
ydim=xdim  ;keep isotropic

self.base =widget_base(title='Christmas Snowfall',column=1,mbar=barBase)
;pull down menu next
fileId = widget_button(barBase, value='File', /menu)
void = widget_button(fileId, /separator, value='Exit', $
           event_pro='snowFallExit')
self.drawId = widget_draw(self.base, xsize=xdim, ysize=ydim, $
                     graphics_level=2, retain=2, renderer=0)

widget_control, self.base, /realize
widget_control, hourglass=1
widget_control, self.drawId, get_value=oWindow
self.oWindow=oWindow

;create the snow surface
snowSurface = randomu(seed, 100, 100)*25.0
; Smooth the array to produce a smooth surface
for j = 0,2 do snowSurface = smooth(snowSurface, 5,/edge)

viewPlane_rect = [-5,-5,110,110]
zclip = [100,-100]
;create Rick Towler's camera object.
self.oCamera = obj_new('Camera', color=[0,0,0], viewplane_rect=viewPlane_rect, $
            projection=2, camera_location=[50,0,30], zclip=zclip, lookat=[50,120,0], $
            /track, eye=101, depth_cue=[-50,10]) ;use depth cueing so the background fades away

;create the model hierarchy

;model for the surface
self.oSurfaceModel = obj_new('IDLgrModel')

;snow surface
oSnowSurface = obj_new('IDLgrSurface',snowSurface,color=[255,255,255],style=2,shading=1,hide=0)
self.oSurfaceModel->add,oSnowSurface

;create a model just for the text
oTextModel = obj_new('IDLgrModel')
displayText = ['Merry Christmas!','From Kling Research and Software, inc']
oFont = obj_new('IDLgrFont','Times*Bold*italic',size=5)
oText = obj_new('IDLgrText',string=displayText,render=1, $
                location=transpose([[50,50],[20,20],[16,14]]), updir=[0,0,1], $
                color=[0,255,0],font = oFont, align=0.5)
oTextModel->add,oText

;add the models to the view
self.oCamera -> add, self.oSurfaceModel
self.oCamera -> add,oTextModel
;light objects
;blue ambient light for effect
oAmbLight = obj_new('IDLgrLight', type=0, color=[0,0,255],intensity=0.4)
;positional light to mimic moonlight
oPosLight1 = obj_new('IDLgrLight', type=1, $
                      color=[255,255,255], location=[xdim*2, ydim/2, 700])

self.oSurfaceModel->Add, [oAmbLight, oPosLight1]

self.oWindow->Draw, self.oCamera

;model for the snowflakes
oSnowflakeModel = obj_new('IDLgrModel')
self.oCamera->add, oSnowflakeModel

for i=0,numSnowflakes-1 do begin
  ;disable the lighting so that flakes appear white and not blue
  oSnowFlake = obj_new('snowflake',viewPlane_rect=viewPlane_rect,$
                        zclip=zclip, parentObject=self, lighting=0)
  oSnowflakeModel->add, oSnowFlake
  self.oWindow->Draw, self.oCamera
endfor


;store objects for cleanup
self.oContainer = obj_new('IDL_Container')
self.oContainer-> add, self.oSurfaceModel
self.oContainer-> add, [oSnowflakeModel,oTextModel, oFont, oText]
;store the object reference in the base
widget_control, self.base,set_uvalue=self

xmanager,'snowFall',self.base,/no_block,cleanup='snowFallCleanup'

return,1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro snowFall::cleanup
;cleanup routine for the snowFall object

self->idlGrModel::cleanup
if obj_valid(self.oContainer) then obj_destroy,self.oContainer
if obj_valid(self.oWindow) then obj_destroy,self.oWindow
if obj_valid(self.oCamera) then obj_destroy,self.oCamera

if ptr_valid(self.message) then ptr_free, self.message

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro snowFall__define

;defintion routine for the snowFall object
void = {snowFall, $
        inherits IDLgrmodel, $
        base : 0L, $
        drawId : 0L, $
        oWindow : obj_new(), $
        oCamera : obj_new(), $
        oSnowflakeModel : obj_new(), $
        oSurfaceModel : obj_new(), $
        oContainer : obj_new(), $
        message : ptr_new() }

return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|


pro snowFall, numSnowflakes=numSnowflakes, _extra=extra
;driver routine for the snowfall visualization

oSnowFall = obj_new('snowFall',numSnowflakes=numSnowflakes, _extra=extra)

return & end
